function initChart(){
  // Load the Visualization API and the piechart package.
  google.load('visualization', '1.0', {'packages':['corechart']});

  // Set a callback to run when the Google Visualization API is loaded.
  google.setOnLoadCallback(doChart);

}

function drawChart(datos,title,id) {
  // Set chart options
  var options = {'title':title,
                 'width':1024,
                 'height':300};

  // Instantiate and draw our chart, passing in some options.
  var chart = new google.visualization.BarChart(document.getElementById(id));
  chart.draw(datos, options);
}

// Callback that creates and populates a data table,
// instantiates the pie chart, passes in the data and
// draws it.
function doChart(){
    var datos1= new google.visualization.DataTable();
    datos1.addColumn('string','App');
    datos1.addColumn('number','Count');

    var datos2= new google.visualization.DataTable();
    datos2.addColumn('string','App');
    datos2.addColumn('number','Count');
    
    var datos3= new google.visualization.DataTable();
    datos3.addColumn('string','App');
    datos3.addColumn('number','Count');
    
    //Gets Data from DB
    $.getJSON( "./GetStats", function( json ) {
        // Log each key in the response data
        $.each( json[0], function( key, value ) {
            //console.log( '0 ->'+key + " : " + value );
            datos1.addRow([key,parseInt(value)]);
        });
        while (datos1.Gf.length < 10)
          datos1.addRow(['',0])
        $.each( json[1], function( key, value ) {
            //console.log( '1 ->'+key + " : " + value );
            datos2.addRow([key,parseInt(value)]);
        });
        while (datos2.Gf.length < 10)
          datos2.addRow(['',0])
        $.each( json[2], function( key, value ) {
            //console.log( '2 ->'+key + " : " + value );
            datos3.addRow([key,parseInt(value)]);
        });
        while (datos3.Gf.length < 10)
          datos3.addRow(['',0]);
        drawChart(datos1,'Top apps este mes','chart_div1');
        drawChart(datos2,'Top apps ultimo mes','chart_div2');
        drawChart(datos3,'Top apps penultimo mes','chart_div3');
    });
    
}

$(document).ready(initChart());
